<?php
class LdapObjClassDef {
    var $oid;
    var $name;
    var $desc;
    var $sup;
    var $type;
    var $must;
    var $may;
    
    function LdapObjClassDef($rawDefinition) {
        $this->oid="";
        $this->name="";
        $this->desc="";
        $this->sup="";
        $this->type="";
        $this->must=array();
        $this->may=array();
        $objInfo=substr($rawDefinition,1,strlen($rawDefinition)-2);
        $tok=strtok($objInfo," ");
        $this->oid=$tok;
        $tok=strtok(" ");
        while ($tok!==false) {
            if (strcmp($tok,"NAME")==0) {
                $this->name=strtok(" ");
                if (strcmp($this->name,"(")==0) {
                    $this->name=strtok(" ");
                }
                $this->name=substr($this->name,1,strlen($this->name)-2);
            }
            else if (strcmp($tok,"DESC")==0) {
                $this->desc=strtok(" ");
                $this->desc=substr($this->desc,1);
                while (strpos($this->desc,"'")===false) {
                    $this->desc.=" ".strtok(" ");
                }
                $this->desc=substr($this->desc,0,strlen($this->desc)-1);
            }
            else if (strcmp($tok,"SUP")==0) {
                $this->sup=strtok(" ");
            }
            else if (strcmp($tok,"STRUCTURAL")==0) {
                $this->type="Structural";
            }
            else if (strcmp($tok,"AUXILIARY")==0) {
                $this->type="Auxiliary";
            }
            else if (strcmp($tok,"MUST")==0) {
                $tok=strtok(" ");
                if (strpos($tok,"(")!==false) {
                    $tok=strtok(" ");
                    while (strpos($tok,")")===false) {
                        if (strcmp($tok,"$")!=0) {
                            array_push($this->must,$tok);
                        }
                        $tok=strtok(" ");
                    }
                }
                else {
                    array_push($this->must,$tok);
                }
            }
            else if (strcmp($tok,"MAY")==0) {
                $tok=strtok(" ");
                if (strpos($tok,"(")!==false) {
                    $tok=strtok(" ");
                    while (strpos($tok,")")===false) {
                        if (strcmp($tok,"$")!=0) {
                            array_push($this->may,$tok);
                        }
                        $tok=strtok(" ");
                    }
                }
                else {
                    array_push($this->may,$tok);
                }
            }
            $tok=strtok(" ");
        }
    }
    
    function getName() {
        return $this->name;
    }
    
    function getMustAttributes() {
        return $this->must;
    }
    
    function getMayAttributes() {
        return $this->may;
    }
    
    function getType() {
        return $this->type;
    }
    
    function getXML($fullInfo) {
        if (!$fullInfo) {
            $res='<ObjectClass name="'.$this->name.'" type="'.$this->type.'"/>';
        }
        else {
            $res='<ObjectClass oid="'.$this->oid.'" name="'.$this->name.'" description="'.$this->desc.'" sup="'.$this->sup.'" type="'.$this->type.'" must="'.implode(",",$this->must).'" may="'.implode(",",$this->may).'"/>';
        }
        return $res;
    }
}
?>